//**********************
// OSCCON Function with only dsPIC30F2012 CQ board
// 
// (C)Copyright 2010 All rights reserved by Y.Onodera
// http://einstlab.web.fc2.com
//**********************
#if defined(__dsPIC30F__)
#include <p30fxxxx.h>
#elif defined(__dsPIC33F__)
#include <p33Fxxxx.h>
#elif defined(__PIC24H__)
#include <p24Hxxxx.h>
#elif defined(__PIC24F__)
#include <p24Fxxxx.h>
#endif


void InitOSC(unsigned int i){

	// FRC=7.37MHz
	// FRC_PLL		COSC = 001
	// FRC_PLLx4	COSC = 111,FPR = 00001
	// FRC_PLLx8	COSC = 111,FPR = 01010
	// FRC_PLLx16	COSC = 111,FPR = 00011 default
	// /1 POST=00
	// /4 POST=01
	// /16 POST=10
	// /64 POST=11

	// form FRC_PLLx16 POST=00 to FRC_PLLx16 POST=01
	__builtin_write_OSCCONH((i>>8) & 0xff);	// Set NOSC
	__builtin_write_OSCCONL((i & 0xff) | 0x01);	// Set OSWEN
//	while(OSCCONbits.OSWEN==0);		// wait
	while(OSCCONbits.LOCK==0);		// wait

	// if you need to tune
	// dsPIC	PIC24
	// 0111(10.5%)	011111(Max)
	// 0110(9.0%)	011110
	// 0101(7.5%)
	// 0100(6.0%)
	// 0011(4.5%)
	// 0010(3.0%)
	// 0001(1.5%)
	// 0000(0.0%)	000000
	// 1111(-1.5%)
	// 1110(-3.0%)
	// 1101(-4.5%)
	// 1100(-6.0%)
	// 1011(-7.5%)
	// 1010(-9.0%)
	// 1001(-10.5%)	100001
	// 1000(-12.5%)	100000(Min)
	OSCTUN=0x00;

	// RCDIV for PIC24
	// 111=31.25KHz
	// 110=125KHz
	// 101=250KHz
	// 100=500KHz
	// 011=1MHz
	// 010=2MHz
	// 001=4MHz
	// 000=8MHz
//	CLKDIVbits.RCDIV=0x1;

}


